;"This line left intentionally nonsense" - frisst der Assembler im List-File ;)
; ****************************************************************************
; *                              Projekt W006S005                            *
; *            Firmware fr Geocaching-Magnetbake 5x7DotMatrix LED           *
; *                             auf Atmel AVR-Basis                          *
; ****************************************************************************
; *                                                                          *
; *               (c) 2009-2014 Jochen Wienstroth                            *
; *               wienstroth Elektronikentwicklung                           *
; *               Am Deutschherrenberg 33                                    *
; *               D-35578 Wetzlar                                            *
; *               Tel: auf Anfrage / Fax: 03222-1168698                      *
; *               http://www.hw-entwickler.de                                *
; *               mailto: jw@hw-entwickler.de                                *
; *                                                                          *
; *                                                     2014-05-20           *
; *                                                                          *
; ****************************************************************************
; *                                                                          *
; *                Die Nutzung dieser Software ist nur erlaubt im            *
; *                Rahmen der Lizenz Creative Commons CC-BY-NC-SA            *
; *                V3.0 - siehe auch                                         *
; *                                                                          *
; *               http://creativecommons.org/licenses/by-nc-sa/3.0/          *
; *                                                                          *
; *                Jede Abweichung der Nutzung dieser Software               *
; *                von den genannten Bestimmungen darf nur                   *
; *                mit schriftlicher Genehmigung durch den oben              *
; *                genannten Urheberrechtsinhaber erfolgen !                 *
; *                                                                          *
; ****************************************************************************




; ****************************************************************************

.equ 	SWVER = 0x04          ;Firmware-Version

;                             Firmware-Historie:
;                             ==================

;   V0.04 (2014-05-20 *JWie*)
;  Spielen an diversen Parametern rund um Reaktivlicht-Funktionalitt, Prio-
;  ritt Auslsung vor Tagbergang.

;   V0.03 (2013-02-19 *JWie*)
;
;  Reaktivlicht-Funktionalitt hinzugefgt, bentigt als Reaktivlicht (und nur
;  da) Hardware nach W006Z005V002 und damit Handfdelungen auf W006L005V001 
;  oder das angepasste Layout W006L005V002.
;  Zustzliche Zeichen im CharROM: SYM_SMILE (Smiley) und SYM_HERZ (Herzchen)
;  Freie Zeichen fr Ausgabetext: 416 Zeichen
;  Stromverbrauch: Tagmodus bzw. Magnetbake 6A, Nachtmodus 14A

;   V0.02 (2013-06-03 *JWie*)
;
;  Weiches "Tacho-Scrollen" wie mechanische Rollenanzeige hinzugefgt

;	V0.01 (2013-03-14 *JWie*)
;
;  Erste Version, ausschlielich Magnetbaken-Funktionalitt.


.equ    HWVER = 0x5003	     ;Hardware-Version

;                            Hardware-Historie:
;                            ==================


;   W006Z005V003 (2014-03-03 *JWie*)
;
;   Umsetzung von V002 in SMD auf eigener Platine W006L005V002, Ergnzung 
;   diverser verschiedener Anzeige-LED-Farben als Bestckungsvariante.

;   W006Z005V002 (2013-06-10 *JWie*)
;
;   Schaltungsnderungen fr Reaktivlicht: RC-Glied bestehend aus LDR VT93N1
;   und 10nF parallelgeschaltet zwischen PA7/ADC6 und Masse. LDR muss seine
;   Masseverbindung handgefdelt bekommen, Kondensator kann an Stelle von R3
;   in 0603 auf der Unterseite der Platine W006L005V001 bestckt werden.
;

;   W006Z005V001 (2013-03-14 *JWie*)
;
;   Prototypen in THT nach Schaltplan W006Z005V001 bzw. auf Leiterplatte
;   W006L005V001.

.CSEG			                ;Code-Start		

;*****************************************************************************
;*****************************************************************************
;*                   Unterscheidung Entwicklung <-> Anwender                 *
;*****************************************************************************
;*****************************************************************************
;#define EW							; Entwickler bekommen Assembler-Quellcode
;*****************************************************************************
#ifdef EW
 .include "W006S005.asm"			; Entwickler bekommen Assembler-Quellcode,
#else
 .include "W6S5.inc"				; Anwender bekommen dot-deeh-double-youh
#endif
;*****************************************************************************
 
.include "Sonderzeichen.inc"		; Konstantennamen Sonderzeichen einbinden

;*****************************************************************************
;*****************************************************************************
;*                           Auszugebende Nachricht                          *
;*****************************************************************************
;*****************************************************************************
BOTBEG:							; Anfang auszugebende Nachricht
;*****************************************************************************
#ifndef	GENATDW					; Nachricht nur im Normalbetrieb einbauen
;*****************************************************************************
.equ FLCONF = 0b11111000        ; Konfigurationsbyte Flash
;               |||||||+--------- Bit0: reserviert, bitte 0 lassen
;               ||||||+---------- Bit1: reserviert, bitte 0 lassen
;               |||||+----------- Bit2: LDRTST, LDR-Test: Helligkeitsmessung
;               ||||+------------ Bit3: REAKTIV, 0=Magnetbake, 1=Reaktivlicht
;               |||+------------- Bit4: SCROLL, 1=Ausgabe als "Rollenanzeige"
;               ||+-------------- Bit5: UPSDWN, 1=Ausgabe "auf dem Kopf"
;               |+--------------- Bit6: COLINV, Spaltenansteuerung invertiert
;               +---------------- Bit7: ROWINV, Zeilenansteuerung invertiert

;.equ ADAUER = 60 				; Anzeigedauer jedes Zeichens x10ms, (NORMAL)
.equ ADAUER = 7                 ; Anzeigedauer pro Scrollschritts x10ms, (SCROLL)
								; Beispiel: 80 = 800ms Anzeigedauer
;.equ PDAUER = 5                 ; Pausenzeit nach jedem Zeichen x10ms, (NORMAL)
.equ PDAUER = 30				; Pausenzeit nach jedem Zeichen x10ms, (SCROLL)
                                ; Beispiel: 5 = 50ms Pausenzeit
.equ DSCHWELL = 48              ; Dunkel-Schwelle: Bei kleinerer Helligkeit
                                ; schaltet Reaktivlicht in Nachtmodus
.equ HSCHWELL = 128             ; Hell-Schwelle: Bei grerer Helligkeit
                                ; schaltet Reaktivlicht in Tagmodus
.equ SPRUNG = 3                 ; Sprung-Hhe: Hherer Sprung lst Reaktiv-
                                ; licht im Dunkelmodus aus.

	.db FLCONF, DSCHWELL        ; Konfiguration, Dunkelschw. im Flash ablegen
	.db HSCHWELL, SPRUNG        ; Hellschwelle, Sprunghhe im Flash ablegen
	.db ADAUER, PDAUER          ; Anzeigedauer, Pausendauer im Flash ablegen
	.dw ((BOTEND-BOTBEG-4)<<1)  ; Lnge des Strings im Flash ablegen
							

; Hier folgt der eigentliche Ausgabe-Text. Einfach Klartext schreiben,
; Sonderzeichen und hufig bentigte Zeichen oberhalb des klassischen
; 7-Bit-ASCII (Umlaute, Euro-Zeichen, Grad-Zeichen (), Fortschrittsbalken
; und andere lustige Pseudografiken) finden sich als Konstanten vordefiniert
; in Sonderzeichen.inc, dort einfach nachsehen ob und was sich passendes
; findet und hier mit Konstantennamen im Text einfgen.

	.db "Hallo! Finde N48",SYM_DEG," 51.493 E002",SYM_DEG," 17.670 und H=324m. "	
	.db SYM_SMILE,"V004",SYM_SMILE

; Bitte darauf achten, dass in jeder "Textzeile" eine gerade Anzahl an Zeichen
; steht, sonst fllt der Assembler die Zeile automatisch nach hinten mit einem
; Leerzeichen auf und gibt eine Warning aus. Diese kann man ignorieren, aber
; hbsch geht anders....

;*****************************************************************************
BOTEND:						; Ende von Ausgabestring
;*****************************************************************************
#endif

;*****************************************************************************
;*****************************************************************************
;*                                PROGRAMM-ENDE                              *
;*****************************************************************************
;*****************************************************************************
